diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/he-frame-exchange-manager.cc ns-3.44/src/wifi/model/he/he-frame-exchange-manager.cc
--- ns-3.43/src/wifi/model/he/he-frame-exchange-manager.cc	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/he-frame-exchange-manager.cc	2025-03-09 16:55:49.791372500 -0700
@@ -2004,7 +2079,7 @@
 
     if (psdu->GetAddr1() == m_self)
     {
-        // When the received frame’s RA is equal to the STA’s own MAC address, the STA
+        // When the received frame's RA is equal to the STA's own MAC address, the STA
         // shall not update its NAV (IEEE 802.11-2020, sec. 10.3.2.4)
         return;
     }
@@ -2035,7 +2110,7 @@
     }
 
     // For all other received frames the STA shall update its NAV when the received
-    // Duration is greater than the STA’s current NAV value (IEEE 802.11-2020 sec. 10.3.2.4)
+    // Duration is greater than the STA's current NAV value (IEEE 802.11-2020 sec. 10.3.2.4)
     auto intraBssNavEnd = Simulator::Now() + duration;
     if (intraBssNavEnd > m_intraBssNavEnd)
     {
@@ -2058,7 +2133,7 @@
             auto navResetDelay =
                 2 * m_phy->GetSifs() +
                 WifiPhy::CalculateTxDuration(GetCtsSize(), ctsTxVector, m_phy->GetPhyBand()) +
-                m_phy->CalculatePhyPreambleAndHeaderDuration(ctsTxVector) + 2 * m_phy->GetSlot();
+                WifiPhy::CalculatePhyPreambleAndHeaderDuration(ctsTxVector) + 2 * m_phy->GetSlot();
             m_intraBssNavResetEvent =
                 Simulator::Schedule(navResetDelay,
                                     &HeFrameExchangeManager::IntraBssNavResetTimeout,
@@ -2176,6 +2251,8 @@
                                     const WifiTxVector& txVector,
                                     bool inAmpdu)
 {
+    NS_LOG_FUNCTION(this << *mpdu << rxSignalInfo << txVector << inAmpdu);
+
     // The received MPDU is either broadcast or addressed to this station
     NS_ASSERT(mpdu->GetHeader().GetAddr1().IsGroup() || mpdu->GetHeader().GetAddr1() == m_self);
 
@@ -2291,21 +2368,7 @@
         }
 
         NS_LOG_DEBUG("Received a QoS Null frame in a TB PPDU from " << sender);
-
-        // remove the sender from the set of stations that are expected to send a TB PPDU
-        m_txTimer.GotResponseFrom(sender);
-
-        if (m_txTimer.GetStasExpectedToRespond().empty())
-        {
-            // we do not expect any other response
-            m_txTimer.Cancel();
-            m_channelAccessManager->NotifyAckTimeoutResetNow();
-
-            NS_ASSERT(m_edca);
-            m_psduMap.clear();
-            m_edca->ResetCw(m_linkId);
-            TransmissionSucceeded();
-        }
+        ReceivedQosNullAfterBsrpTf(sender);
 
         // the received TB PPDU has been processed
         return;
@@ -2332,9 +2395,7 @@
 
             m_txTimer.Cancel();
             m_channelAccessManager->NotifyCtsTimeoutResetNow();
-            Simulator::Schedule(m_phy->GetSifs(),
-                                &HeFrameExchangeManager::ProtectionCompleted,
-                                this);
+            ProtectionCompleted();
         }
         else if (hdr.IsCts() && m_txTimer.IsRunning() &&
                  m_txTimer.GetReason() == WifiTxTimer::WAIT_CTS_AFTER_MU_RTS)
@@ -2346,9 +2407,7 @@
 
             m_txTimer.Cancel();
             m_channelAccessManager->NotifyCtsTimeoutResetNow();
-            Simulator::Schedule(m_phy->GetSifs(),
-                                &HeFrameExchangeManager::ProtectionCompleted,
-                                this);
+            ProtectionCompleted();
         }
         else if (hdr.IsAck() && m_txTimer.IsRunning() &&
                  m_txTimer.GetReason() == WifiTxTimer::WAIT_NORMAL_ACK_AFTER_DL_MU_PPDU)
@@ -2443,6 +2502,7 @@
             NS_ABORT_MSG_IF(!blockAck.IsMultiSta(),
                             "A Multi-STA BlockAck is expected after a TB PPDU");
             NS_LOG_DEBUG("Received a Multi-STA BlockAck from=" << hdr.GetAddr2());
+            m_txTimer.GotResponseFrom(hdr.GetAddr2());
 
             NS_ASSERT(m_staMac && m_staMac->IsAssociated());
             if (hdr.GetAddr2() != m_bssid)
@@ -2582,12 +2642,12 @@
                 // - The UL MU CS condition indicates that the medium is idle
                 // (Sec. 26.2.6.3 of 802.11ax-2021)
                 NS_LOG_DEBUG("Schedule CTS");
-                Simulator::Schedule(m_phy->GetSifs(),
-                                    &HeFrameExchangeManager::SendCtsAfterMuRts,
-                                    this,
-                                    hdr,
-                                    trigger,
-                                    rxSignalInfo.snr);
+                m_sendCtsEvent = Simulator::Schedule(m_phy->GetSifs(),
+                                                     &HeFrameExchangeManager::SendCtsAfterMuRts,
+                                                     this,
+                                                     hdr,
+                                                     trigger,
+                                                     rxSignalInfo.snr);
             }
             else if (trigger.IsMuBar())
             {
@@ -2750,21 +2810,7 @@
         }
 
         NS_LOG_DEBUG("Received QoS Null frames in a TB PPDU from " << sender);
-
-        // remove the sender from the set of stations that are expected to send a TB PPDU
-        m_txTimer.GotResponseFrom(sender);
-
-        if (m_txTimer.GetStasExpectedToRespond().empty())
-        {
-            // we do not expect any other response
-            m_txTimer.Cancel();
-            m_channelAccessManager->NotifyAckTimeoutResetNow();
-
-            NS_ASSERT(m_edca);
-            m_psduMap.clear();
-            m_edca->ResetCw(m_linkId);
-            TransmissionSucceeded();
-        }
+        ReceivedQosNullAfterBsrpTf(sender);
 
         // the received TB PPDU has been processed
         return;
@@ -2791,4 +2837,30 @@
     VhtFrameExchangeManager::EndReceiveAmpdu(psdu, rxSignalInfo, txVector, perMpduStatus);
 }
 
+void
+HeFrameExchangeManager::ReceivedQosNullAfterBsrpTf(Mac48Address sender)
+{
+    NS_LOG_FUNCTION(this << sender);
+
+    NS_ASSERT(m_txTimer.IsRunning() &&
+              m_txTimer.GetReason() == WifiTxTimer::WAIT_QOS_NULL_AFTER_BSRP_TF);
+
+    // remove the sender from the set of stations that are expected to send a TB PPDU
+    m_txTimer.GotResponseFrom(sender);
+
+    if (m_txTimer.GetStasExpectedToRespond().empty())
+    {
+        // we do not expect any other response
+        m_channelAccessManager->NotifyAckTimeoutResetNow();
+
+        NS_ASSERT(m_edca);
+        m_psduMap.clear();
+        m_edca->ResetCw(m_linkId);
+        TransmissionSucceeded();
+        // we reset the TX timer after calling TransmissionSucceeded, so that the latter can
+        // check whether the reason for the last timer is WAIT_QOS_NULL_AFTER_BSRP_TF
+        m_txTimer.Cancel();
+    }
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/he-frame-exchange-manager.h ns-3.44/src/wifi/model/he/he-frame-exchange-manager.h
--- ns-3.43/src/wifi/model/he/he-frame-exchange-manager.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/he-frame-exchange-manager.h	2025-03-09 16:55:49.791372500 -0700
@@ -20,35 +20,24 @@
 {
 
 class MultiUserScheduler;
-class ApWifiMac;
-class StaWifiMac;
 class CtrlTriggerHeader;
 
 /**
- * Map of PSDUs indexed by STA-ID
- */
-typedef std::unordered_map<uint16_t /* staId */, Ptr<WifiPsdu> /* PSDU */> WifiPsduMap;
-/**
- * Map of const PSDUs indexed by STA-ID
- */
-typedef std::unordered_map<uint16_t /* staId */, Ptr<const WifiPsdu> /* PSDU */> WifiConstPsduMap;
-
-/**
- * \param psduMap a PSDU map
- * \return true if the given PSDU map contains a single PSDU including a single MPDU
+ * @param psduMap a PSDU map
+ * @return true if the given PSDU map contains a single PSDU including a single MPDU
  *         that carries a Trigger Frame
  */
 bool IsTrigger(const WifiPsduMap& psduMap);
 
 /**
- * \param psduMap a PSDU map
- * \return true if the given PSDU map contains a single PSDU including a single MPDU
+ * @param psduMap a PSDU map
+ * @return true if the given PSDU map contains a single PSDU including a single MPDU
  *         that carries a Trigger Frame
  */
 bool IsTrigger(const WifiConstPsduMap& psduMap);
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * HeFrameExchangeManager handles the frame exchange sequences
  * for HE stations.
@@ -57,15 +46,14 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     HeFrameExchangeManager();
     ~HeFrameExchangeManager() override;
 
     bool StartFrameExchange(Ptr<QosTxop> edca, Time availableTime, bool initialFrame) override;
-    void SetWifiMac(const Ptr<WifiMac> mac) override;
     void CalculateAcknowledgmentTime(WifiAcknowledgment* acknowledgment) const override;
     void CalculateProtectionTime(WifiProtection* protection) const override;
     std::optional<Mac48Address> FindTxopHolder(const WifiMacHeader& hdr,
@@ -75,7 +63,7 @@
     /**
      * Set the Multi-user Scheduler associated with this Frame Exchange Manager.
      *
-     * \param muScheduler the Multi-user Scheduler associated with this Frame Exchange Manager
+     * @param muScheduler the Multi-user Scheduler associated with this Frame Exchange Manager
      */
     void SetMultiUserScheduler(const Ptr<MultiUserScheduler> muScheduler);
 
@@ -83,9 +71,9 @@
      * Get the PSDU in the given PSDU map that is addressed to the given MAC address,
      * if any, or a null pointer, otherwise.
      *
-     * \param to the MAC address
-     * \param psduMap the PSDU map
-     * \return the PSDU, if any, or a null pointer, otherwise
+     * @param to the MAC address
+     * @param psduMap the PSDU map
+     * @return the PSDU, if any, or a null pointer, otherwise
      */
     static Ptr<WifiPsdu> GetPsduTo(Mac48Address to, const WifiPsduMap& psduMap);
 
@@ -94,7 +82,7 @@
      * Trigger Frame to the most recent RSSI observed from the corresponding
      * station.
      *
-     * \param trigger the given Trigger Frame
+     * @param trigger the given Trigger Frame
      */
     virtual void SetTargetRssi(CtrlTriggerHeader& trigger) const;
 
@@ -102,8 +90,8 @@
      * Get the RSSI of the most recent packet received from the station having
      * the given address.
      *
-     * \param address of the remote station
-     * \return the RSSI of the most recent packet received from the remote station
+     * @param address of the remote station
+     * @return the RSSI of the most recent packet received from the remote station
      */
     virtual std::optional<dBm_u> GetMostRecentRssi(const Mac48Address& address) const;
 
@@ -111,9 +99,9 @@
      * Return whether the received frame is classified as intra-BSS. It is assumed that
      * this station is already associated with an AP.
      *
-     * \param psdu the received PSDU
-     * \param txVector TX vector of the received PSDU
-     * \return true if the received frame is classified as intra-BSS, false otherwise
+     * @param psdu the received PSDU
+     * @param txVector TX vector of the received PSDU
+     * @return true if the received frame is classified as intra-BSS, false otherwise
      *         (the received frame is classified as inter-BSS or it cannot be classified
      *         as intra-BSS or inter-BSS)
      */
@@ -123,12 +111,20 @@
      * This method is intended to be called a SIFS after the reception of a Trigger Frame
      * to determine whether the station is allowed to respond.
      *
-     * \param trigger the Trigger Frame soliciting a response
-     * \return true if CS is not required or the UL MU CS mechanism indicates that the medium
+     * @param trigger the Trigger Frame soliciting a response
+     * @return true if CS is not required or the UL MU CS mechanism indicates that the medium
      *         is idle, false otherwise
      */
     bool UlMuCsMediumIdle(const CtrlTriggerHeader& trigger) const;
 
+    /**
+     * Get the (link) address of the non-AP stations solicited by the given Trigger Frame.
+     *
+     * @param trigger the given Trigger Frame
+     * @return the (link) address of the non-AP stations solicited by the given Trigger Frame
+     */
+    std::set<Mac48Address> GetTfRecipients(const CtrlTriggerHeader& trigger) const;
+
   protected:
     void DoDispose() override;
     void Reset() override;
@@ -169,11 +165,11 @@
      * Compute how to set the Duration/ID field of an MU-RTS Trigger Frame to send to protect
      * a frame transmitted with the given TX vector.
      *
-     * \param muRtsSize the size of the MU-RTS Trigger Frame in bytes
-     * \param muRtsTxVector the TX vector used to send the MU-RTS Trigger Frame
-     * \param txDuration the TX duration of the data frame
-     * \param response the time taken by the response (acknowledgment) to the data frame
-     * \return the computed Duration/ID value for the MU-RTS Trigger Frame
+     * @param muRtsSize the size of the MU-RTS Trigger Frame in bytes
+     * @param muRtsTxVector the TX vector used to send the MU-RTS Trigger Frame
+     * @param txDuration the TX duration of the data frame
+     * @param response the time taken by the response (acknowledgment) to the data frame
+     * @return the computed Duration/ID value for the MU-RTS Trigger Frame
      */
     virtual Time GetMuRtsDurationId(uint32_t muRtsSize,
                                     const WifiTxVector& muRtsTxVector,
@@ -181,51 +177,40 @@
                                     Time response) const;
 
     /**
-     * Record the stations being solicited by an MU-RTS TF.
-     *
-     * \param txParams the TX parameters for the data frame protected by the MU-RTS TF.
-     */
-    void RecordSentMuRtsTo(const WifiTxParameters& txParams);
-
-    /**
      * Send an MU-RTS to begin an MU-RTS/CTS frame exchange protecting an MU PPDU.
      *
-     * \param txParams the TX parameters for the data frame
+     * @param txParams the TX parameters for the data frame
      */
     virtual void SendMuRts(const WifiTxParameters& txParams);
 
     /**
      * Called when no CTS frame is received after an MU-RTS.
      *
-     * \param muRts the MU-RTS that solicited CTS responses
-     * \param txVector the TXVECTOR used to transmit the MU-RTS frame
+     * @param muRts the MU-RTS that solicited CTS responses
+     * @param txVector the TXVECTOR used to transmit the MU-RTS frame
      */
     virtual void CtsAfterMuRtsTimeout(Ptr<WifiMpdu> muRts, const WifiTxVector& txVector);
 
     /**
      * Called when no CTS frame is received after an MU-RTS.
      *
-     * \param muRts the MU-RTS that solicited CTS responses
-     * \param txVector the TXVECTOR used to transmit the MU-RTS frame
-     * \param updateFailedCw whether to update CW in case of retransmission after TX failure
-     */
-    void DoCtsAfterMuRtsTimeout(Ptr<WifiMpdu> muRts,
-                                const WifiTxVector& txVector,
-                                bool updateFailedCw);
+     * @param psduMap the PSDU map protected by the failed MU-RTS
+     */
+    void DoCtsAfterMuRtsTimeout(const WifiPsduMap& psduMap);
 
     /**
      * Send CTS after receiving an MU-RTS.
      *
-     * \param muRtsHdr the MAC header of the received MU-RTS
-     * \param trigger the MU-RTS Trigger Frame header
-     * \param muRtsSnr the SNR of the MU-RTS in linear scale
+     * @param muRtsHdr the MAC header of the received MU-RTS
+     * @param trigger the MU-RTS Trigger Frame header
+     * @param muRtsSnr the SNR of the MU-RTS in linear scale
      */
     virtual void SendCtsAfterMuRts(const WifiMacHeader& muRtsHdr,
                                    const CtrlTriggerHeader& trigger,
                                    double muRtsSnr);
 
     /**
-     * \return the mode used to transmit a CTS after an MU-RTS.
+     * @return the mode used to transmit a CTS after an MU-RTS.
      */
     WifiMode GetCtsModeAfterMuRts() const;
 
@@ -233,9 +218,9 @@
      * Get the TXVECTOR that the station having the given station ID has to use to send a
      * CTS frame after receiving an MU-RTS Trigger Frame from the AP it is associated with.
      *
-     * \param trigger the MU-RTS Trigger Frame
-     * \param staId the station ID for MU
-     * \return the TXVECTOR to use to send a CTS frame
+     * @param trigger the MU-RTS Trigger Frame
+     * @param staId the station ID for MU
+     * @return the TXVECTOR to use to send a CTS frame
      */
     WifiTxVector GetCtsTxVectorAfterMuRts(const CtrlTriggerHeader& trigger, uint16_t staId) const;
 
@@ -244,16 +229,16 @@
      * Note that both <i>psduMap</i> and <i>txParams</i> are moved to m_psduMap and
      * m_txParams, respectively, and hence are left in an undefined state.
      *
-     * \param psduMap the map of PSDUs to send
-     * \param txParams the TX parameters to use to transmit the PSDUs
+     * @param psduMap the map of PSDUs to send
+     * @param txParams the TX parameters to use to transmit the PSDUs
      */
     void SendPsduMapWithProtection(WifiPsduMap psduMap, WifiTxParameters& txParams);
 
     /**
      * Forward a map of PSDUs down to the PHY layer.
      *
-     * \param psduMap the map of PSDUs to transmit
-     * \param txVector the TXVECTOR used to transmit the MU PPDU
+     * @param psduMap the map of PSDUs to transmit
+     * @param txVector the TXVECTOR used to transmit the MU PPDU
      */
     virtual void ForwardPsduMapDown(WifiConstPsduMap psduMap, WifiTxVector& txVector);
 
@@ -262,8 +247,8 @@
      * in response to a DL MU PPDU. This method must not be called if all the
      * expected BlockAck frames were received.
      *
-     * \param psduMap a pointer to PSDU map transmitted in a DL MU PPDU
-     * \param nSolicitedStations the number of stations solicited to send a TB PPDU
+     * @param psduMap a pointer to PSDU map transmitted in a DL MU PPDU
+     * @param nSolicitedStations the number of stations solicited to send a TB PPDU
      */
     virtual void BlockAcksInTbPpduTimeout(WifiPsduMap* psduMap, std::size_t nSolicitedStations);
 
@@ -272,17 +257,28 @@
      * response to Trigger Frame. This method must not be called if all the
      * expected TB PPDUs were received.
      *
-     * \param psduMap a pointer to PSDU map transmitted in a DL MU PPDU
-     * \param nSolicitedStations the number of stations solicited to send a TB PPDU
+     * @param psduMap a pointer to PSDU map transmitted in a DL MU PPDU
+     * @param nSolicitedStations the number of stations solicited to send a TB PPDU
      */
     virtual void TbPpduTimeout(WifiPsduMap* psduMap, std::size_t nSolicitedStations);
 
     /**
+     * Take the necessary actions after that some TB PPDUs are missing in
+     * response to Trigger Frame. This method must not be called if all the
+     * expected TB PPDUs were received.
+     *
+     * @param psduMap a pointer to PSDU map transmitted in a DL MU PPDU
+     * @param nSolicitedStations the number of stations solicited to send a TB PPDU
+     * @param updateFailedCw whether to update CW in case the transmission failed
+     */
+    void DoTbPpduTimeout(WifiPsduMap* psduMap, std::size_t nSolicitedStations, bool updateFailedCw);
+
+    /**
      * Take the necessary actions after that a Block Ack is missing after a
      * TB PPDU solicited through a Trigger Frame.
      *
-     * \param psdu the PSDU in the TB PPDU
-     * \param txVector the TXVECTOR used to transmit the TB PPDU
+     * @param psdu the PSDU in the TB PPDU
+     * @param txVector the TXVECTOR used to transmit the TB PPDU
      */
     virtual void BlockAckAfterTbPpduTimeout(Ptr<WifiPsdu> psdu, const WifiTxVector& txVector);
 
@@ -290,8 +286,8 @@
      * Get the TRIGVECTOR that the MAC has to pass to the PHY when transmitting
      * the given Trigger Frame.
      *
-     * \param trigger the given Trigger Frame
-     * \return the TRIGVECTOR
+     * @param trigger the given Trigger Frame
+     * @return the TRIGVECTOR
      */
     WifiTxVector GetTrigVector(const CtrlTriggerHeader& trigger) const;
 
@@ -301,9 +297,9 @@
      * level to use for the consequent HE TB PPDU.
      * Note that this method should only be called by non-AP stations only.
      *
-     * \param trigger the received Trigger frame
-     * \param triggerSender the MAC address of the AP sending the Trigger frame
-     * \return TXVECTOR for the HE TB PPDU frame
+     * @param trigger the received Trigger frame
+     * @param triggerSender the MAC address of the AP sending the Trigger frame
+     * @return TXVECTOR for the HE TB PPDU frame
      */
     WifiTxVector GetHeTbTxVector(CtrlTriggerHeader trigger, Mac48Address triggerSender) const;
 
@@ -315,9 +311,9 @@
      * Note that the number of recipients must match the number of users addressed
      * by the given TXVECTOR.
      *
-     * \param responseTxVector the given TXVECTOR
-     * \param recipients the list of BlockAckReq headers indexed by the station's AID
-     * \return the MPDU containing the built MU-BAR
+     * @param responseTxVector the given TXVECTOR
+     * @param recipients the list of BlockAckReq headers indexed by the station's AID
+     * @return the MPDU containing the built MU-BAR
      */
     Ptr<WifiMpdu> PrepareMuBar(const WifiTxVector& responseTxVector,
                                std::map<uint16_t, CtrlBAckRequestHeader> recipients) const;
@@ -325,8 +321,8 @@
     /**
      * Send a Multi-STA Block Ack frame after the reception of some TB PPDUs.
      *
-     * \param txParams the TX parameters for the Trigger Frame that solicited the TB PPDUs
-     * \param durationId the Duration/ID field of the HE TB PPDU that elicited the Multi-STA
+     * @param txParams the TX parameters for the Trigger Frame that solicited the TB PPDUs
+     * @param durationId the Duration/ID field of the HE TB PPDU that elicited the Multi-STA
      *                   Block Ack response
      */
     void SendMultiStaBlockAck(const WifiTxParameters& txParams, Time durationId);
@@ -336,13 +332,20 @@
      * of QoS Null frames that are actually aggregated depends on the available time
      * as indicated by the Trigger Frame and is at most 8 (one QoS Null frame per TID).
      *
-     * \param trigger the Basic or BSRP Trigger Frame content
-     * \param hdr the MAC header of the Basic or BSRP Trigger Frame
+     * @param trigger the Basic or BSRP Trigger Frame content
+     * @param hdr the MAC header of the Basic or BSRP Trigger Frame
+     */
+    virtual void SendQosNullFramesInTbPpdu(const CtrlTriggerHeader& trigger,
+                                           const WifiMacHeader& hdr);
+
+    /**
+     * Perform the actions required when receiving QoS Null frame(s) from the given sender after
+     * a BSRP Trigger Frame.
+     *
+     * @param sender the MAC address of the given sender
      */
-    void SendQosNullFramesInTbPpdu(const CtrlTriggerHeader& trigger, const WifiMacHeader& hdr);
+    virtual void ReceivedQosNullAfterBsrpTf(Mac48Address sender);
 
-    Ptr<ApWifiMac> m_apMac;          //!< MAC pointer (null if not an AP)
-    Ptr<StaWifiMac> m_staMac;        //!< MAC pointer (null if not a STA)
     WifiTxVector m_trigVector;       //!< the TRIGVECTOR
     Time m_intraBssNavEnd;           //!< intra-BSS NAV expiration time
     EventId m_intraBssNavResetEvent; //!< the event to reset the intra-BSS NAV after an RTS
@@ -356,18 +359,18 @@
     /**
      * Take the necessary actions when receiving a Basic Trigger Frame.
      *
-     * \param trigger the Basic Trigger Frame content
-     * \param hdr the MAC header of the Basic Trigger Frame
+     * @param trigger the Basic Trigger Frame content
+     * @param hdr the MAC header of the Basic Trigger Frame
      */
     void ReceiveBasicTrigger(const CtrlTriggerHeader& trigger, const WifiMacHeader& hdr);
 
     /**
      * Respond to a MU-BAR Trigger Frame (if permitted by UL MU CS mechanism).
      *
-     * \param trigger the Basic Trigger Frame content
-     * \param tid the TID requested for us in the MU-BAR Trigger Frame
-     * \param durationId the Duration/ID field of the MPDU carrying the Trigger Frame
-     * \param snr the receive SNR
+     * @param trigger the Basic Trigger Frame content
+     * @param tid the TID requested for us in the MU-BAR Trigger Frame
+     * @param durationId the Duration/ID field of the MPDU carrying the Trigger Frame
+     * @param snr the receive SNR
      */
     void ReceiveMuBarTrigger(const CtrlTriggerHeader& trigger,
                              uint8_t tid,
@@ -381,6 +384,8 @@
     EventId m_multiStaBaEvent;             //!< Sending a Multi-STA BlockAck event
     MuSnrTag m_muSnrTag;                   //!< Tag to attach to Multi-STA BlockAck frames
     bool m_triggerFrameInAmpdu;            //!< True if the received A-MPDU contains an MU-BAR
+    bool m_continueTxopAfterBsrpTf; //!< whether to continue a TXOP a SIFS after the reception of
+                                    //!< responses to a BSRP TF when TXOP limit is zero
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/he-operation.h ns-3.44/src/wifi/model/he/he-operation.h
--- ns-3.43/src/wifi/model/he/he-operation.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/he-operation.h	2025-03-09 16:55:49.791372500 -0700
@@ -17,8 +17,8 @@
 {
 
 /**
- * \brief The HE Operation Information Element
- * \ingroup wifi
+ * @brief The HE Operation Information Element
+ * @ingroup wifi
  *
  * This class knows how to serialise and deserialise
  * the HE Operation Information Element
@@ -48,27 +48,27 @@
         /**
          * Print the content of the HE Operation Parameters field.
          *
-         * \param os output stream
+         * @param os output stream
          */
         void Print(std::ostream& os) const;
 
         /**
-         * \return the serialized size of the HE Operation Parameters field
+         * @return the serialized size of the HE Operation Parameters field
          */
         uint16_t GetSerializedSize() const;
 
         /**
          * Serialize the HE Operation Parameters field
          *
-         * \param start an iterator which points to where the information should be written
+         * @param start an iterator which points to where the information should be written
          */
         void Serialize(Buffer::Iterator& start) const;
 
         /**
          * Deserialize the HE Operation Parameters field.
          *
-         * \param start an iterator which points to where the information should be read from
-         * \return the number of bytes read
+         * @param start an iterator which points to where the information should be read from
+         * @return the number of bytes read
          */
         uint16_t Deserialize(Buffer::Iterator& start);
     };
@@ -83,27 +83,27 @@
         /**
          * Print the content of the BSS Color Information field.
          *
-         * \param os output stream
+         * @param os output stream
          */
         void Print(std::ostream& os) const;
 
         /**
-         * \return the serialized size of the BSS Color Information field
+         * @return the serialized size of the BSS Color Information field
          */
         uint16_t GetSerializedSize() const;
 
         /**
          * Serialize the BSS Color Information field
          *
-         * \param start an iterator which points to where the information should be written
+         * @param start an iterator which points to where the information should be written
          */
         void Serialize(Buffer::Iterator& start) const;
 
         /**
          * Deserialize the BSS Color Information field.
          *
-         * \param start an iterator which points to where the information should be read from
-         * \return the number of bytes read
+         * @param start an iterator which points to where the information should be read from
+         * @return the number of bytes read
          */
         uint16_t Deserialize(Buffer::Iterator& start);
     };
@@ -123,27 +123,27 @@
         /**
          * Print the content of the 6 GHz Operation Information field.
          *
-         * \param os output stream
+         * @param os output stream
          */
         void Print(std::ostream& os) const;
 
         /**
-         * \return the serialized size of the 6 GHz Operation Information field
+         * @return the serialized size of the 6 GHz Operation Information field
          */
         uint16_t GetSerializedSize() const;
 
         /**
          * Serialize the 6 GHz Operation Information field
          *
-         * \param start an iterator which points to where the information should be written
+         * @param start an iterator which points to where the information should be written
          */
         void Serialize(Buffer::Iterator& start) const;
 
         /**
          * Deserialize the 6 GHz Operation Information field.
          *
-         * \param start an iterator which points to where the information should be read from
-         * \return the number of bytes read
+         * @param start an iterator which points to where the information should be read from
+         * @return the number of bytes read
          */
         uint16_t Deserialize(Buffer::Iterator& start);
     };
@@ -152,8 +152,8 @@
      * Set the Basic HE-MCS and NSS field in the HE Operation information element
      * by specifying the pair (<i>nss</i>, <i>maxMcs</i>).
      *
-     * \param nss the NSS
-     * \param maxHeMcs the maximum supported HE-MCS value corresponding to that NSS
+     * @param nss the NSS
+     * @param maxHeMcs the maximum supported HE-MCS value corresponding to that NSS
      */
     void SetMaxHeMcsPerNss(uint8_t nss, uint8_t maxHeMcs);
 
